aboutsummaryrefslogtreecommitdiffstats
path: root/contrib/init.d
diff options
context:
space:
mode:
authormvanbaak <mvanbaak@f38db490-d61c-443f-a65b-d21fe96a405b>2009-02-21 13:13:35 +0000
committermvanbaak <mvanbaak@f38db490-d61c-443f-a65b-d21fe96a405b>2009-02-21 13:13:35 +0000
commit7421c44b11479277fe71b95ec5b0e286918c7d72 (patch)
tree93fbf45ec6291d167e7a644983bb0f63f5141661 /contrib/init.d
parentaa99ddd21253ddd33a945727b8a6aea5f6df6ea0 (diff)
set ASTVARRUNDIR=$(localstatedir)/run/asterisk as default path
When running asterisk as non-root and without this patch the pidfile wants to go into /var/run/asterisk.pid. This directory is not writable for the non-root user and changing permissions is not an option. Putting it in /var/run/asterisk/asterisk.pid makes it possible to set permissions on the /var/run/asterisk dir so everything works as it should be. Patched committed is based on pabelanger's patch. (closes issue #13153) Reported by: pabelanger Patches: 2009012900_bug13153-nonrootscripts.diff.txt uploaded by mvanbaak (license 7) Review: http://reviewboard.digium.com/r/139/ git-svn-id: http://svn.digium.com/svn/asterisk/trunk@177852 f38db490-d61c-443f-a65b-d21fe96a405b
Diffstat (limited to 'contrib/init.d')
-rwxr-xr-xcontrib/init.d/rc.archlinux.asterisk15
-rwxr-xr-xcontrib/init.d/rc.debian.asterisk26
2 files changed, 27 insertions, 14 deletions
diff --git a/contrib/init.d/rc.archlinux.asterisk b/contrib/init.d/rc.archlinux.asterisk
index a4b7c633c..fec62af98 100755
--- a/contrib/init.d/rc.archlinux.asterisk
+++ b/contrib/init.d/rc.archlinux.asterisk
@@ -8,26 +8,31 @@
#
. /etc/rc.conf
. /etc/rc.d/functions
+DAEMON=__ASTERISK_SBIN_DIR__/asterisk
+ASTVARRUNDIR=__ASTERISK_VARRUN_DIR__
case "$1" in
start)
stat_busy "Starting Asterisk..."
- if [ -x /usr/sbin/asterisk ]; then
+ if [ ! -d $ASTVARRUNDIR ]; then
+ mkdir -p $ASTVARRUNDIR
+ fi
+ if [ -x $DAEMON ]; then
# Check if Asterisk is already running. If it is, then bug out, because
# starting safe_asterisk when Asterisk is running is very bad.
- VERSION=`/usr/sbin/asterisk -rx 'core show version'`
+ VERSION=`${DAEMON} -rx 'core show version'`
if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
echo "Asterisk is already running. $0 will exit now."
exit 1
fi
- /usr/sbin/asterisk
+ ${DAEMON}
stat_done
fi
;;
stop)
- if [ -r /var/run/asterisk.pid ]; then
+ if [ -r ${ASTVARRUNDIR}/asterisk.pid ]; then
stat_busy "Stoping Asterisk..."
- asterisk -rx "core stop now" > /dev/null 2&>1
+ ${DAEMON} -rx "core stop now" > /dev/null 2&>1
if [ $? -gt 0 ]; then
stat_fail
else
diff --git a/contrib/init.d/rc.debian.asterisk b/contrib/init.d/rc.debian.asterisk
index 76406dbd6..86babe83f 100755
--- a/contrib/init.d/rc.debian.asterisk
+++ b/contrib/init.d/rc.debian.asterisk
@@ -21,7 +21,9 @@ PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
NAME=asterisk
DESC="Asterisk PBX"
# Full path to asterisk binary
-DAEMON=/usr/sbin/asterisk
+DAEMON=__ASTERISK_SBIN_DIR__/asterisk
+ASTVARRUNDIR=__ASTERISK_VARRUN_DIR__
+ASTETCDIR=__ASTERISK_ETC_DIR__
TRUE=/bin/true
# Uncomment this ONLY if you know what you are doing.
@@ -42,8 +44,8 @@ if ! [ -x $DAEMON ] ; then
exit 0
fi
-if ! [ -d /etc/asterisk ] ; then
- echo "ERROR: /etc/asterisk directory not found"
+if ! [ -d $ASTETCDIR ] ; then
+ echo "ERROR: $ASTETCDIR directory not found"
exit 0
fi
@@ -61,12 +63,18 @@ case "$1" in
fi
log_begin_msg "Starting $DESC: $NAME"
- if [ $AST_USER ] ; then
- ASTARGS="-U $AST_USER"
- fi
- if [ $AST_GROUP ] ; then
- ASTARGS="$ASTARGS -G $AST_GROUP"
- fi
+ if [ ! -d $ASTVARRUNDIR ]; then
+ mkdir -p $ASTVARRUNDIR
+ fi
+
+ if [ $AST_USER ] ; then
+ ASTARGS="-U $AST_USER"
+ chown $AST_USER $ASTVARRUNDIR
+ fi
+ if [ $AST_GROUP ] ; then
+ ASTARGS="$ASTARGS -G $AST_GROUP"
+ chown $AST_GROUP $ASTVARRUNDIR
+ fi
# "start-stop-daemon --oknodo" returns 0 even if Asterisk was already running (as LSB expects):
start-stop-daemon --start --oknodo --exec $DAEMON -- $ASTARGS
log_end_msg $?